// Proof of concept plastic pellets to powder grinder
// More on https://HomoFaciens.de

$fn=100;


M3_hole = 3.5;
M3_nut_e = 6.3;
M4_hole = 4.5;
M5_hole = 5.5;
M6_hole = 6.5;
M4_nut_e = 7.66 + 0.3;
M5_nut_e = 8.79 + 0.3;
M6_nut_e = 11.05 + 0.3;
M8_nut_e = 14.38+1.5;
M8_hole=8.5;

bb8_do = 22 + 0.5;
bb8_h = 7;

bb10_do = 30 + 0.5;
bb10_h = 9;


// Mount screws
m_dis1 = 68;
m_dis2 = 105;

// Stator
m_r1 = 16;
m_r2 = sqrt(m_dis1/2*m_dis1/2+m_dis2/2*m_dis2/2);
hole_no = 46;
h_start = 5.5;


blender_wall = 5;
blender_di = 2 * m_r2 + 9;
blender_do = blender_di + 2 * blender_wall;
blender_h = 60;
blade_d = 60;

assembled = 0;
cut_model = 0;

sieve_w = 60;
sieve_h = blender_h - 20;

can_r_mount = blender_do/2+6;

if(assembled)
difference(){
  union(){
//    color([0.9, 0.1, 0.1])bottom(bb8_do, bb8_h);

//    translate([0, 0, 11])
//    color([0.6, 0.6, 0.6])
//    can(blender_do-11, 5, blender_h-33.5);

//    translate([0, 0, 11])color([0.0, 0.6, 0.6])stator(40, 3);
  
//    color([0.9, 0.9, 0.0])blade(25);
    
    color([0.9, 0.9, 0.0])
    mount();
    
    color([0.4, 0.4, 0.9])
    translate([0, 0, blender_h+15])rotate([0, 180, 0])can();  
  }
  if(cut_model)
  translate([blender_do/2, 0, 0])
  cube(size=[blender_do, 300, 300], center=true);
}
else{
//  drill_template();  
//  translate([0, -80, 0])rotate([0, 0, 90])outlet();  
  can();
//  translate([-100, 0, 0])rotor();
//  translate([-100, 0, 0])lid();
//  mount();
//  bearing_mount();

}

module bearing_mount(){
  bm_wall = 2;
  bm_h = bb8_h+bm_wall;
  bm_do = 44; 

  translate([0, 0, bm_h/2])
  difference(){
    cylinder(d=bm_do, h=bm_h, center=true);
    translate([0, 0, 2])
    cylinder(d=bb8_do, h=bm_h, center=true);
    
    cylinder(d=bb8_do-5, h=bm_h+0.1, center=true);

    rotate([0, 0, 30])
    translate([20, 0, 0])
    cylinder(d=10.5, h=bm_h+0.1, center=true);
    
    // Can mount holes
    for(i=[0:60:300])rotate([0, 0, i]){
      translate([m_r1, 0, 0]){
        cylinder(d=M4_hole, h=bm_h+0.1, center=true);
        translate([0, 0, 6-bm_h])
        hull(){
          cylinder(d=M4_hole, h=bm_h, center=true);
          translate([0, 0, -2])
          rotate([0, 0, 30])
          cylinder(d=M4_nut_e, h=bm_h-2, center=true, $fn=6);
        }
      }
    }
  }


}


module mount(){
  m_h = 10;
  m_do = blender_do+30;
  m_di = 110;
  m_wall = 2;
  
  
  
  translate([0, 0, m_h/2])
  difference(){
    cylinder(d=m_do, h=m_h, center=true);
    
    translate([-blender_do, 0, 0])
    cube(size=[blender_do, blender_do, m_h+0.1], center=true);
    cylinder(d=m_di, h=m_h+0.1, center=true);
    
    translate([0, 0, m_wall])
    cylinder(r=m_r2+7, h=m_h, center=true);
    
    for(i=[0:90:270])rotate([0, 0, i+45])
    translate([blender_do/2+6, 0, 0]){
      cylinder(r=M6_hole, h=m_h+0.1, center=true);
      translate([0, 0, m_h/2])
      cylinder(r=M6_nut_e+2, h=12, center=true);
    }
    
    // Mount holes router
    translate([m_dis1/2, m_dis2/2, 0])
    cylinder(d=M4_hole, h=m_h+0.1, center=true);
    translate([-m_dis1/2, m_dis2/2, 0])
    cylinder(d=M4_hole, h=m_h+0.1, center=true);
    translate([-m_dis1/2, -m_dis2/2, 0])
    cylinder(d=M4_hole, h=m_h+0.1, center=true);
    translate([m_dis1/2, -m_dis2/2, 0])
    cylinder(d=M4_hole, h=m_h+0.1, center=true);
  }
}

module rotor(){
  r_d1 = 15;
  r_d2 = 25;
  r_h1 = 5;
  r_h2 = 16;
  
  difference(){
    union(){
      translate([0, 0, r_h2/2])
      cylinder(d=r_d2, h=r_h2, center=true);
    }
    translate([0, 0, r_h2/2])
    cylinder(d=M8_hole, h=r_h2+0.1, center=true);

    for(i=[0:1:1])mirror([i,0,0]){
      translate([r_d1/2, 0, r_h2/2])
      cylinder(d=M3_hole, h=r_h2+0.1, center=true);    
      
      hull(){
        translate([4, 0, r_h1+r_h2/2])
        cylinder(d=6, h=r_h2, center=true);
        translate([r_d2/2, 0, r_h1+r_h2/2])
        cube(size=[0.1, 30, r_h2], center=true);
      }
    }
  }
}

module lid(){
  l_do = 95;
  l_di = 86;
  l_h = 2;
  
  difference(){
    cylinder(d=l_do, h=l_h, center=true);
    cylinder(d=l_di, h=l_h+0.1, center=true);
  }
  
}

module outlet(){
  c_wall = 7;
  o_wall = 2;
  o_h = 55;
  o_w = 10;
  o_l = blender_h + 25;
  o_do = 20;
  o_di = o_do - 4;

  // Frame
  translate([-40, 0, 0])
  rotate([0, 90, 0])
  difference(){
    hull(){
      translate([0, 0, blender_h/2])
      rotate([90, 0, -90])
      roundedRect([sieve_w+2*c_wall, blender_h, o_w], 5);
//      translate([-o_do/2, 0, blender_h+o_l/2])
//      cylinder(d=o_do, h=o_l, center=true);
      
    }
    translate([1, 0, blender_h/2])
    rotate([90, 0, -90])
    roundedRect([sieve_w, sieve_h, o_w+2], 5);
    
    
    // Sieve mount holes
    translate([0, 0, blender_h/2])
    for(i=[0:1:1])mirror([0,0,i]){
      for(j=[0:1:1])mirror([0,j,0])
      translate([0, sieve_w/2+2, sieve_h/2+5])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=50, center=true);
      }

      translate([0, 0, sieve_h/2+5])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=50, center=true);
      }
    }
    
    
  }

  // Lid
  // Filter dimensions
  f_d = 20;
  f_y = -14;
  f_z = 30;
  
  translate([-50, 0, 0])
  difference(){
    union(){
      translate([0, 0, blender_h/2])
      rotate([90, 0, -90])
      roundedRect([sieve_w+2*c_wall, blender_h, o_wall], 5);
      translate([-o_do/2, 17, o_l/2])
      cylinder(d=o_do, h=o_l, center=true);
      hull(){
        translate([-o_do/2, 17, blender_h/2])
        cylinder(d=o_do, h=blender_h, center=true);
        translate([-1, 17, blender_h/2])
        cube(size=[1, o_do, blender_h], center=true);
      }
      
      // Brim
      brim_h = 0.35;
      brim_d = 15;
      translate([0, sieve_w/2+c_wall, brim_h/2])
      cylinder(d=brim_d, h=brim_h, center=true);
      translate([0, -(sieve_w/2+c_wall), brim_h/2])
      cylinder(d=brim_d, h=brim_h, center=true);
      
      // Filter
      translate([-5, f_y, f_z])
      rotate([0, 90, 0])
      cylinder(d1=f_d+2*c_wall, d2=f_d+25, h=10, center=true);
      
    }
    

    translate([-o_do/2, 17, o_l/2+2])
    cylinder(d=o_di, h=o_l, center=true);

    translate([1, 17, blender_h/2])
    rotate([0, -90, 0])
    roundedRect([blender_h-4, o_di, o_do/2+1], 5);
    
    // Filter
    translate([-5, f_y, f_z])
    rotate([0, 90, 0]){
      cylinder(d1=f_d, d2=f_d, h=10.1, center=true);
      for(i=[0:90:270])rotate([0, 0, i])
      translate([f_d/2+4, 0, 0]){
        cylinder(d=M3_hole, h=10.1, center=true);
        translate([0, 0, 25])
        rotate([0, 0, 30])
        cylinder(d=M3_nut_e, h=50, center=true, $fn=6);
      }
    }

    // Sieve mount holes
    translate([0, 0, blender_h/2])
    for(i=[0:1:1])mirror([0,0,i]){
      for(j=[0:1:1])mirror([0,j,0])
      translate([0, sieve_w/2+2, sieve_h/2+5])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=50, center=true);
      }

      translate([0, 0, sieve_h/2+5])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=50, center=true);
      }
    }
  }

  // Filter lid
  translate([-72, -15, 1])
  difference(){
    cylinder(d=f_d+2*c_wall, h=2, center=true);
    for(i=[0:90:270])rotate([0, 0, i])
    translate([f_d/2+4, 0, 0])
    cylinder(d=M3_hole, h=10.1, center=true);
  }

}

module drill_template(){
  b_l = 150;
  b_w = 150;
  socket_h = 12;
  socket_d = 80;
  b_h = 60;
  b_d_bot = blade_d*sqrt(2);
//  alpha = atan2(b_h, (blender_e - blade_d)/2);
  
  difference(){
    union(){
      roundedRect([b_l, b_w, blender_wall+1], 5);
    }

    difference(){
      translate([0, 0, 1.5])
      roundedRect([b_l+0.1, b_w+0.1, blender_wall], 5);

      // Ball bearing mount holes
      for(i=[0:60:300])rotate([0, 0, i]){
        translate([m_r1, 0, socket_h/2-2])
        cylinder(d=M4_hole+4, h=socket_h, center=true);
      }

    // Can mount holes
    for(i=[0:90:270])rotate([0, 0, i+45]){
      translate([can_r_mount, 0, 0])
      cylinder(d=M4_hole+4, h=socket_h, center=true);
    }


      // Stator mount holes
      for(i=[0:1:hole_no-1])rotate([0, 0, i*360/hole_no+h_start]){
        translate([m_r2, 0, socket_h/2])
        cylinder(d=M4_hole+4, h=socket_h+0.1, center=true);
      }

      translate([0, 0, socket_h/2])
      cylinder(d=M4_hole+4, h=socket_h+0.1, center=true);

    }

    // shaft cut
    translate([0, 0, socket_h/2])
    cylinder(d=4, h=socket_h+0.1, center=true);
    
    // Ball bearing mount holes
    for(i=[0:60:300])rotate([0, 0, i]){
      translate([m_r1, 0, socket_h/2-2])
      cylinder(d=4, h=socket_h, center=true);
    }

    // Stator mount holes
    for(i=[0:1:hole_no-1])rotate([0, 0, i*360/hole_no+h_start]){
      translate([m_r2, 0, socket_h/2])
      cylinder(d=4, h=socket_h+0.1, center=true);
    }
    
    for(i=[0:60:300])rotate([0, 0, i])
    translate([40, 0, 0])
    cylinder(d=30, h=50, center=true);
    
    // Can mount holes
    for(i=[0:90:270])rotate([0, 0, i+45]){
      translate([can_r_mount, 0, 0])
      cylinder(d=4, h=socket_h+0.1, center=true);
    }

    
  }
}

module blade(blade_h = 7){
  blade_s_h = 20;
  blade_shaft = 8;
  
  translate([0, 0, blade_s_h/2])
  cylinder(d=blade_shaft, h=blade_s_h, center=true);
  translate([0, 0, blade_s_h+blade_h/2]){
    for(i=[0:90:270])rotate([0, 0, i])
    hull(){
      translate([0, blade_d/2, 0])
      cube(size=[0.1, 0.1, blade_h], center=true);
      cylinder(d=20, h=blade_h, center=true);
    }
  }

}

module stator(s_h = 40, edges = 3){
  // stator
  for(i=[0:1:11])rotate([0, 0, i*30]){
    translate([0, 0, 2.5])
    rotate([90, 0, 0])
    cylinder(d=M6_hole, h=blade_d, center=true);
    translate([m_r2-i*0.24, 0, s_h/2])
    rotate([0, 0, 180])
    cylinder(d=M6_hole, h=s_h, center=true, $fn=edges);
    translate([m_r2-i*0.24, 0, 3])
    cylinder(d=M6_nut_e, h=6, center=true, $fn=6);
  }  
}

module can(){
  c_wall = 7;

  translate([0, 0, blender_h/2])
  difference(){
    union(){
      cylinder(d=blender_do, h=blender_h, center=true);
      for(i=[0:90:270])rotate([0, 0, i+45])
      hull(){
        translate([blender_do/2, 0, 0])
        cylinder(d=12, h=blender_h, center=true);
        translate([can_r_mount, 0, 0])
        cylinder(d=12, h=blender_h, center=true);
      }
      translate([0, 0, 0])
      rotate([90, 0, 0])
      roundedRect([sieve_w+2*c_wall, blender_h, blender_do/2], 5);
    }
    
    // inner cut
    translate([0, 0, 10])
    cylinder(d=blender_di, h=blender_h, center=true);
    cylinder(d=blender_di-17, h=blender_h+0.1, center=true);

    // Stator holes
    for(i=[0:1:hole_no-1])rotate([0, 0, i*360/hole_no+h_start]){
      translate([m_r2, 0, 0])
      cylinder(d=4, h=blender_h+0.1, center=true);
    }
    

    // Sieve cut
    difference(){
      translate([0, 0, 0])
      rotate([90, 0, 0])
      roundedRect([sieve_w, sieve_h, blender_do/2-0.5], 5);

      cylinder(d=blender_di+1, h=blender_h, center=true);
    }
    translate([0,-blender_do/2, 0])
    rotate([90, 0, 0])
    cylinder(d=2, h=blender_do+5, center=true);

    // Mount holes can
    for(i=[0:90:270])rotate([0, 0, i+45]){
      translate([can_r_mount, 0, 0])
      cylinder(d=M6_hole, h=blender_h+0.1, center=true);
    }
    
    // Sieve mount holes
    for(i=[0:1:1])mirror([0,0,i]){
      for(j=[0:1:1])mirror([j,0,0])
      translate([sieve_w/2+2, -blender_do/2, sieve_h/2+5])
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=50, center=true);
        translate([0, 0, -25-2])
        cylinder(d=M3_nut_e, h=50, center=true, $fn=6);
      }

      translate([0, -blender_do/2, sieve_h/2+5])
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=50, center=true);
        translate([0, 0, -25-2])
        cylinder(d=M3_nut_e, h=50, center=true, $fn=6);
      }
    }
  }
}


module roundedRect(size, radius, edges=[1, 1, 1, 1], vscale=[1,1], shift=0){
  x = size[0];
  y = size[1];
  z = size[2];

  translate([0, -shift*2, 0]){
    linear_extrude(height=z, scale=[vscale[0], vscale[1]]){
      translate([0, shift*2, 0]){
        hull(){
            // place 4 circles in the corners, with the given radius
            if(edges[0]){
              translate([(-x/2)+(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
            if(edges[1]){
              translate([(x/2)-(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[2]){
              translate([(-x/2)+(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[3]){
              translate([(x/2)-(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
          }
       }
    }
  }
}
